package com.vendor.platform.ui.update;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.platform.core.IToolManager;
import com.vendor.platform.core.PlatformCoreActivator;
import com.vendor.platform.core.ToolDescriptor;
import com.vendor.platform.core.internal.DeviceManager;
import com.vendor.platform.ui.internal.ToolStateControlUtils;
import com.vendor.platform.ui.update.UpdateFileChecker;
import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.equinox.p2.metadata.IInstallableUnit;

public class UpdateFileInstaller implements Runnable {
  public static final com.vendor.platform.ui.update.UpdateFileInstaller INSTANCE = new com.vendor.platform.ui.update.UpdateFileInstaller();
  
  protected boolean isOK = false;
  
  public boolean isOK() {
    return this.isOK;
  }
  
  public void run() {
    IToolManager toolManager = PlatformCoreActivator.getDefault().getToolManager();
    HashMap<String, ToolDescriptor> updateList = UpdateFileChecker.INSTANCE.getUpdateFileList();
    for (Map.Entry<String, ToolDescriptor> entry : updateList.entrySet()) {
      String newToolPath = entry.getKey();
      File toolFile = new File(newToolPath);
      if (!toolFile.exists())
        continue; 
      ToolDescriptor newTool = entry.getValue();
      ToolDescriptor oldTool = null;
      List<IInstallableUnit> installIUs = PlatformCoreActivator.getDefault().getToolManager().getInstalledToolAndPlatformIUs();
      List<ToolDescriptor> listTools = toolManager.collectFeatureToolsAndPlatform(installIUs);
      for (ToolDescriptor tool : listTools) {
        if (tool.getName().equals(newTool.getName()))
          oldTool = tool; 
      } 
      if (oldTool == null) {
        if (!toolFile.delete())
          System.out.print("Delete temp file failed."); 
        continue;
      } 
      try {
        ToolStateControlUtils.setAutoModifyToolState(oldTool, null);
        toolManager.uninstallIU(oldTool.iu, (IProgressMonitor)new NullProgressMonitor());
      } catch (Exception e) {
        if (!toolFile.delete())
          System.out.print("Delete temp file failed."); 
        continue;
      } 
      try {
        toolManager.installIU(newToolPath, newTool.iu, (IProgressMonitor)new NullProgressMonitor());
        IInstallableUnit iu = toolManager.findInstallIU(newTool.iu.getId(), newTool.iu
            .getVersion().toString());
        if (iu != null) {
          ToolDescriptor installedTool = new ToolDescriptor(iu);
          DeviceManager deviceManager = (DeviceManager)DeviceManager.getInstance();
          deviceManager.combinedNewToolSuiltableChips((String)installedTool
              .getProperties().get("build.id"), (String)installedTool
              .getProperties().get("Chips"));
        } 
      } catch (Exception e) {
        if (!toolFile.delete())
          System.out.print("Delete temp file failed."); 
        continue;
      } 
      if (!toolFile.delete())
        System.out.print("Delete temp file failed."); 
    } 
    this.isOK = true;
  }
}
